#!/bbn/bin/perl

$DEBUG = 1;

use ExtUtils::testlib;

require 'getopts.pl';

use Oraperl;

#DO NOT require user_specs.pl in this package.  it will infinite loop

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/username.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';

# *********************************************************
# This Procedure gets the query from the input stream
# *********************************************************
sub get_query
{
  if ($ENV{'REQUEST_METHOD'} eq 'GET')
  {
    $query_string = $ENV{'QUERY_STRING'};
  # Parse input query string
    &parse($query_string);
    &write_comment("GET METHOD: query is $query_string");
  }

  elsif ($ENV{'REQUEST_METHOD'} eq 'POST')
  {
  # Read input buffer
     read( STDIN, $query_string, $ENV{'CONTENT_LENGTH'} );
  # Optional printout
  # print "<BR>BUFFER is $query_string\n";
  # print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<P>\n";
# Parse input query string
  &parse($query_string);
  }
}

# ******************************************
# write the caw back header
# ******************************************
sub caw_frameD_back_header
{
   $doc = 'com_ed1/index.html';
   $image = 'com_media/caw_header_back_button.gif';
   print "<A NAME=\"pagetop\"></A>\n";
   print "<A HREF=\"$docpath$doc\" TARGET=\"_parent\">\n";
   print "<IMG SRC=\"$docpath$image\"\n";
   print " ALIGN=\"MIDDLE\" WIDTH=\"430\" HEIGHT=\"32\" BORDER=0></A>\n";

 # print "<A HREF=\"$docpath/com_ed1/index.html\" TARGET=\"_parent\">\n";
 # print "<IMG SRC=\"$docpath/com_media/caw_header_back_button.gif\"\n";
 # print " ALIGN=\"MIDDLE\" WIDTH=\"430\" HEIGHT=\"32\" BORDER=0></A>\n";
}

# ******************************************
# write caw back to product list header
# ******************************************
sub back_to_caw_products
{
   print "<BR>\n";
   print "<A HREF=\"$plpath/write_gen_types_B.sh\">\n";
   print "<I>back to product list</I></A>\n";
   print "<BR>\n";
}

# ******************************************
# write the frameD topofpage
# ******************************************
sub frameD_topofpage
{
   print "<P ALIGN=\"RIGHT\">\n";
   print "<I>(<A HREF=\"#pagetop\">top of page</A><I>)\n";
   print "</P>\n";
}

# ******************************************
# writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 local ($header_text) = @_;
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print "<HEAD>\n";
 print "<TITLE> $header_text </TITLE>\n";
 print "</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header_1 
{
 local ($header_text) = @_;
#print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print "<HEAD>\n";
 print "<TITLE> $header_text </TITLE>\n";
 print "</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML frame header
# ******************************************
sub html_header_file 
{
 local ($header_text) = @_;
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE> $header_text </TITLE>\n";
 print +"</HEAD>\n";
#print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}
#*************************************
#  oracle login 
#*************************************
sub oracle_login
{
# ==========================================================
# ================= oraperl setup ==========================
# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit" if 0;
# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;
# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;
# ----------------
# get error codes
# ----------------
# require('/usr/oracle/oraperl/src/oraperl.ph');
# ---------------------
# login to the database
# ---------------------
# print "just before ora_login; with user = $user <BR>\n";
  $lda = &ora_login('WG73', $user, $pword)	|| 
                   print "login failed with $ora_errstr<BR>\n";
  if ($DEBUG > 1) {
     &write_comment("End of oraperl setup");
  }
# print "ora_login lda is $lda<BR>\n";
}
#*************************************
#      end sub oracle_login 
#*************************************

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($instring) = @_;
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $instring);
## print "Input string to sub parse is $instring<BR>\n";

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
  #    print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}
# **************************************
#         End of sub parse 
# **************************************

#*******************************************
#         display_graphic 
#*******************************************
sub display_graphic
{
   local($uppermodel) = @_;

   if ($DEBUG > 0) {
      &write_comment("model is $uppermodel; get graphic");
   }
   &write_comment("graphic query is $GET_GRAPHICS"); 
   $csrb = &ora_open($lda, $GET_GRAPHICS)  ||  die $ora_errstr;
   $csrbbind = &ora_bind ($csrb, $uppermodel);
   &write_comment("graphic csrb is $csrb; bind is $csrbbind");
   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      &write_comment("$model has photo file [$photo_filename]-[$photo_extension] for page [$photo_pagetype]");
      $photo_extension =~ tr/A-Z/a-z/;
      if ($photo_extension eq 'bmp') { $photo_extension = 'jpg'; }
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;

      $photo_extension_lc = '.'.$photo_extension;
      $photo_extension_uc = '.'.$photo_extension;
      $photo_extension_lc =~ tr/A-Z/a-z/; 
      $photo_extension_uc =~ tr/A-Z/a-z/; 
      
      $photo_filename_uc = $photo_filename_uc.$photo_extension_uc;
      $photo_filename_lc = $photo_filename_lc.$photo_extension_lc;
      $IMG_SRC = $docpath."com_media/".$photo_filename_lc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_uc;
      &write_comment("Unix photo filename is [$photo_filename_lc]");
      &write_comment("Unix IMG SRC is [$IMG_SRC]");

      $IMG_SRC = $IMG_SRC."\n";
      $IMG_ALT = $IMG_ALT."\n";
      print "<CENTER>\n";
      print "<IMG SRC =\"$IMG_SRC\"  ALT=\"$IMG_ALT\" ALIGN=\"CENTER\">\n";
      print "</CENTER>\n";
   }
   &ora_close($csrb);
}
#*************************************
#  end sub display_graphic
#*************************************

#************************************
#  sub display_productpage_text
#************************************
sub display_productpage_text
{
   local($uppermodel) = @_;

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;
   &ora_bind ($csra, $uppermodel);
   &ora_bind ($csrc, $uppermodel, 'product description');
   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
       &write_comment("number of text files is $ntext\n");
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      if ($DEBUG > 0) {
         &write_comment("model is $uppermodel; get text filename");
      }
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
         &write_comment("after fetch of text_filename");
         $text_filename_stem = $text_filename;
         $text_filename_stem =~ s/\s/_/g;
         $text_filename_stem =~ s/-/_/g;
         $text_filename = $text_filename_stem.".html";
         $text_location = $textpath.$text_filename;
         $text_filenameA = $text_filename_stem.".htm";
         $text_locationA = $textpath.$text_filenameA;
         $text1 = "Unix text filename is [ $text_filename ] or [ $text_filenameA]\n";
         &write_comment( $text1 );
         $text_link = $text_location;
         $text_linkA = $text_locationA;
         open(TEXTFILE, $text_link) || open(TEXTFILE, $text_linkA) || print "<BR>\n";

         print "</CENTER>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
      }
      &ora_close($csra);
   }
}
#**********************************
#   end display_productpage_text
#**********************************

# ******************************************
# Writes download links for model
#   not currently used: D frame links
# ******************************************
sub write_model_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND b.model = :1
                      AND a.obsolete IS NULL";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}

# ******************************************
# Writes download links for model
# ******************************************
sub write_dframe_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND b.model = :1
                      AND a.obsolete IS NULL";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}
# ******************************************
# write caw back to model search
# ******************************************
sub back_to_caw_model_search
{
   print "<BR>\n";
   print "<A HREF=\"$oraclepath/CMODDOCS.com_model_search\">\n";
   print "<I>back to model search</I></A>\n";
   print "<BR>\n";
}


