#!/usr/local/bin/oraperl

# -----------------------
# filename:reg_htpasswd.pl
# 
# written august 1996
# author Barbara Mihalas
# -----------------------

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

# ==========================================================
# ================= oraperl setup ==========================

$ENV{'ORACLE_HOME'}= "/usr/oracle";
$ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
$ENV{'WOW_UID'}= "wow_user/wow_user";
$ENV{'ORACLE_SID'}= "mindy";
## print "query string is $ENV{'QUERY_STRING'}<BR>\n";
## print "oracle_home is $ENV{'ORACLE_HOME'}<BR>\n";
## print "PATH is $ENV{'PATH'}<BR>\n";

# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit"
	if 0;

# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;

# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;

# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');

# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', 'wow_user', 'wow_user')	|| die $ora_errstr;

# ==============  end of oraperl setup =======================
# ============================================================

  $mindypath = 'http://mindy.infomall.org:6399/';   #dv
  $wowpath   = $mindypath.'cgi-bin/wowc/';     #dv
  $morkpath  = 'http://www.carrier.com/';
  $docpath   = $mindypath.'wp/';   #dv
  $textpath  = $docpath.'com_docs/';   #dv
  $adminpath  = '/oradata/disk4/carrier/bwm-admin/';   #dv

# ==============  define cursors =============================


# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

# Read input buffer
  read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );

# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";

# Parse input buffer
# &parse;

# $userid = $value[0];

# &write_back_form ($userid);

  &write_res_passwd;

  &write_com_passwd;

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================

# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;

# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $buffer);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

# *******************************************************
# Write back form on final page after passwd file update
# *******************************************************
sub write_back_form
{
   local($cuserid) = @_;

   $backaction = $wowpath.'REG_UPDATE.list_records';
   print "<FORM ACTION=\"$backaction\">\n";
   print "<INPUT TYPE=\"HIDDEN\" NAME=\"userid\" VALUE=\"$cuserid\">\n";
   print "Return to listing: \n";
   print "<INPUT NAME=\"ureg_status\" VALUE=\"P\" SIZE=1 MAXLENGTH=1>\n";
   print "<INPUT TYPE=\"SUBMIT\" VALUE=\"List Records\">\n";
   print "</FORM>\n";
}

# ***************************************************
# Write res ht access and password files and transfer
# ***************************************************
sub write_res_passwd
{
  $AUTHUSERFILE = 'AuthUserFile /usr/local/etc/httpd/htdocs/private/residential/.htpasswd'; #dv
  $AUTHGROUPFILE = 'AuthGroupFile /usr/local/etc/httpd/htdocs/private/residential/.htgroup';   #dv
  $AUTHNAME = 'AuthName Carrier Residential\nAuthType Basic'; #dv

  &write_comment("<BR> $AUTHUSERFILE<BR>\n");

  $GET_RES_USERS = 
                "SELECT username, user_pw 
                   FROM user_reg
                  WHERE user_permissions LIKE '%H1%'
                  ORDER BY reg_date";

  $csrpw = &ora_open($lda, $GET_RES_USERS) 
           || print "<BR> error in opening $GET_RES_USERS <BR>\n"; 

  $ii =0;
  while ( ($unm, $pw) = &ora_fetch($csrpw) )
  {
     $uname[$ii] = $unm;
     $passw[$ii] = $pw;
     $ii++;
  }  
  &ora_close($csrpw);
  $usernum = $#uname +1;
  &write_comment("after getting user list of $usernum residential users\n");
  print "Database contains $usernum registered users approved for ";
  print "residential downloads.<BR> \n";

# open new htaccess file 
# ----------------------
   $pwfile = "/oradata/disk4/carrier/cdata/files/userfile"; #dv
   open (PWFILE, ">$pwfile") || warn "Couldn't open userfile\n"; 
   select PWFILE;
   print "$AUTHUSERFILE\n";
   print "$AUTHGROUPFILE\n";
   print "$AUTHNAME\n";
   print "<Limit GET POST>\n";
   print "require group res_user\n";

 #    for ($i =0; $i <= $#uname; $i++)
 #    {
 #       print "require user $uname[$i]\n";
 #    }  

   print "</Limit>\n";
   close (PWFILE);
  
# print STDOUT "<BR>after writing access file<BR>\n"; 
  select STDOUT;

# open new htgroup file 
# ----------------------
   $pgfile = "/oradata/disk4/carrier/cdata/files/groupfile"; #dv
   open (PGFILE, ">$pgfile") || warn "Couldn't open groupfile for writing\n"; 

   for ($i =0; $i <= $#uname; $i++)
   {
      print PGFILE "res_user: $uname[$i]\n";
   }  
   close (PGFILE);
       

# open new password file 
# ----------------------
  $ppwfile="/oradata/disk4/carrier/cdata/files/passfile";  #dv
  open(HTPASS, ">$ppwfile");
  for ($i = 0; $i <= $#uname; $i++) {
     $pass = crypt("$passw[$i]","jc");
     print(HTPASS "$uname[$i]:$pass\n");
  }
  close(HTPASS);

  print "New access, password and group files written for Comfort at Home downloads<BR>\n";

  system("/bin/rcp $pwfile mork:/carrier/data-admin/carrier0/private/residential/.htaccess");  #dv
  system("/bin/rcp $ppwfile mork:/carrier/data-admin/carrier0/private/residential/.htpasswd");  #dv
  system("/bin/rcp $pgfile mork:/carrier/data-admin/carrier0/private/residential/.htgroup");  #dv

  print "All files copied to the restricted access Comfort at Home directory.<P>\n";
}
# ***************************************************
# Write com ht access and password files and transfer
# ***************************************************
sub write_com_passwd
{
  $AUTHUSERFILE = 'AuthUserFile /usr/local/etc/httpd/htdocs/private/commercial/.htpasswd'; #dv
  $AUTHGROUPFILE = 'AuthGroupFile /usr/local/etc/httpd/htdocs/private/commercial/.htgroup';   #dv
  $AUTHNAME = 'AuthName Carrier Commercial\nAuthType Basic'; #dv

  &write_comment("<BR> $AUTHUSERFILE<BR>\n");

  $GET_COM_USERS = 
                "SELECT username, user_pw 
                   FROM user_reg
                  WHERE user_permissions LIKE '%W1%'
                  ORDER BY reg_date";

  $csrpwc = &ora_open($lda, $GET_COM_USERS) 
           || print "<BR> error in opening $GET_COM_USERS <BR>\n"; 

  $ii =0;
  while ( ($unm, $pw) = &ora_fetch($csrpwc) )
  {
     $unamec[$ii] = $unm;
     $passwc[$ii] = $pw;
     $ii++;
  }  
  &ora_close($csrpwc);
  
  $usernum = $#unamec +1;
  &write_comment("after getting user list of $usernum commercial users\n");
  print "Database contains $usernum registered users approved for ";
  print "commercial downloads. <BR>\n";

# open new htaccess file 
# ----------------------
   $pwcfile = "/oradata/disk4/carrier/cdata/files/comuserfile"; #dv
   open (PWFILE, ">$pwcfile") || warn "Couldn't open userfile\n"; 
   select PWFILE;
   print "$AUTHUSERFILE\n";
   print "$AUTHGROUPFILE\n";
   print "$AUTHNAME\n";
   print "<Limit GET POST>\n";
   print "require group com_user\n";

   print "</Limit>\n";
   close (PWFILE);
  
# print STDOUT "<BR>after writing access file<BR>\n"; 
  select STDOUT;

# open new htgroup file 
# ----------------------
   $pgcfile = "/oradata/disk4/carrier/cdata/files/comgroupfile"; #dv
   open (PGFILE, ">$pgcfile") || warn "Couldn't open groupfile for writing\n"; 

   for ($i =0; $i <= $#unamec; $i++)
   {
      print PGFILE "com_user: $unamec[$i]\n";
   }  
   close (PGFILE);
       

# open new password file 
# ----------------------
  $ppwcfile="/oradata/disk4/carrier/cdata/files/compassfile";  #dv
  open(HTPASS, ">$ppwcfile");
  for ($i = 0; $i <= $#unamec; $i++) {
     $pass = crypt("$passwc[$i]","cm");
     print(HTPASS "$unamec[$i]:$pass\n");
  }
  close(HTPASS);

  print "New access, password and group files written for Comfort at Work downloads.<BR>\n";

  system("/bin/rcp $pwcfile mork:/carrier/data-admin/carrier0/private/commercial/.htaccess");  #dv
  system("/bin/rcp $ppwcfile mork:/carrier/data-admin/carrier0/private/commercial/.htpasswd");  #dv
  system("/bin/rcp $pgcfile mork:/carrier/data-admin/carrier0/private/commercial/.htgroup");  #dv

  print "All files copied to the restricted access Comfort at Work directory.<P>\n";
}

# ******************************************
# write text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";

}

# ******************************************
# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Placeholder for document title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}
