#!/bbn/bin/perl

# -----------------------
# filename:
# write_com_fieldpage_roomair.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("write product page for Room Air Conditions");
# ===== HTML setup ======

  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  define cursors =============================
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   ORDER BY datatablename";
 
  $GET_TABLENAME   =
                 "SELECT datatablename 
                    FROM commercial_products 
                   WHERE model = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.textid = b.textid";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(pagetype) = :2";
  
   $CAES_CHILLER =
                          "SELECT *
                             FROM CAES_CHILLER
                            WHERE model = :1
                            ORDER BY TO_NUMBER(nomcap)";

   $CMUS_AIR_CONDENSER = 
                          "SELECT *
                             FROM CMUS_AIR_CONDENSER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_AIR_HANDLER =
                          "SELECT *
                             FROM CMUS_AIR_HANDLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";
   
   $CMUS_AIR_TERMINAL =
                          "SELECT *
                             FROM CMUS_AIR_TERMINAL
                            WHERE model = :1
                            ORDER BY modelsize, nomairflow";

   $CMUS_AIR_TERMINAL_BOX =
                          "SELECT *
                             FROM CMUS_AIR_TERMINAL_BOX
                            WHERE model = :1
                            ORDER BY modelsize, nomairflow";

   $CMUS_BOOT_DIFFUSER =
                          "SELECT *
                             FROM CMUS_BOOT_DIFFUSER
                            WHERE model = :1
                            ORDER BY modelsize, nomairflow";

   $CMUS_CHILLER =
                          "SELECT *
                             FROM CMUS_CHILLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_DUAL_FUEL_HEAT_PUMP =
                          "SELECT *
                             FROM CMUS_DUAL_FUEL_HEAT_PUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_FAN_COILS =
                          "SELECT *
                             FROM CMUS_FAN_COILS
                            WHERE model = :1
                            ORDER BY modelsize, netclgcap";

   $CMUS_INDOOR_HORZ_PACK =
                          "SELECT *
                             FROM CMUS_INDOOR_HORZ_PACK
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";
 
   $CMUS_INDOOR_VERT_PACK =
                          "SELECT *
                             FROM CMUS_INDOOR_VERT_PACK
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_INDUCTION_UNIT =
                          "SELECT *
                             FROM CMUS_INDUCTION_UNIT
                            WHERE model = :1";

   $CMUS_PACKROOF_EHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_PACKROOF_EHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACKROOF_GHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_PACKROOF_GHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_AIR_HANDLER =
                          "SELECT *
                             FROM CMUS_PACK_AIR_HANDLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_ELEC_COOL =
                          "SELECT *
                             FROM CMUS_PACK_ELEC_COOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_GAS_HEAT_ELEC_COOL =
                          "SELECT *
                             FROM CMUS_PACK_GAS_HEAT_ELEC_COOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_HEATING_AND_COOLING =
                          "SELECT *
                             FROM CMUS_PACK_HEATING_AND_COOLING
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_HEATPUMP =
                          "SELECT *
                             FROM CMUS_PACK_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_ROOFTOP_HEATPUMP =
                          "SELECT *
                             FROM CMUS_PACK_ROOFTOP_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_TERMINAL_UNIT =
                          "SELECT *
                             FROM CMUS_PACK_TERMINAL_UNIT
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_ROOFTOP_EHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_ROOFTOP_EHEAT_ECOOL
                            WHERE model = :1";

   $CMUS_SPLIT_SYSTEM =
                          "SELECT *
                             FROM CMUS_SPLIT_SYSTEM
                            WHERE model = :1
                            ORDER BY modelsize, condunitclgcap";

   $CMUS_SPLIT_SYSTEM_HEATPUMP =
                          "SELECT *
                             FROM CMUS_SPLIT_SYSTEM_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize";

   $CMUS_WATER_SOURCE_HEATPUMP =
                          "SELECT *
                             FROM CMUS_WATER_SOURCE_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $RAC_UNITS_HC =
                          "SELECT *
                             FROM RAC_UNITS_HC
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_COOL_ONLY =
                          "SELECT *
                             FROM RAC_UNITS_COOL_ONLY
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_HEAT_COOL =
                          "SELECT *
                             FROM RAC_UNITS_HEAT_COOL
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_HEAT_PUMP =
                          "SELECT *
                             FROM RAC_UNITS_HEAT_PUMP
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];

  &write_modelpage ($modelno);

# ==================end  body of program =====================
# ============================================================
# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# ***************************************************
# Gets default fields and builds table
# 9/98 this subroutine is used. do not delete.
# ***************************************************
sub write_default_table_roomair
{
   local ($modelin) = @_;

   $GET_TABLENAME =   "SELECT datatablename
                         FROM commercial_products
                        WHERE upper(model) = :1";  

   &write_comment ("<P><HR><P>Input model to write_default_table is $modelin");

   $csra = &ora_open($lda, $GET_TABLENAME)        || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS)   || die $ora_errstr;

#  Get Name of Product Specifications Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
      &write_comment("upper case of product data table name is $pdtablename");
   }
   &ora_close ($csra);


#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      &ora_bind ($csrb, $pdtablename); 
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
         $units[$ii] = $funits;
         $ii++;
      }

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P><HR><P>\n";
   #  print "product data table name is $pdtablename <BR>\n";
      &write_comment( "query is $GET_DATA ");

      $csrc = &ora_open($lda, $GET_DATA)      || die "failed to open $GET_DATA\n";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

#  Get the indexes for the $#ord default fields 
#  -----------------------------------------------
      for ($ii=0; $ii <= $#ord; $ii++)
      {
         $fieldname[$ii] =~ tr/a-z/A-Z/;

    # Get matching fieldname
    # ----------------------
         for ($idat=0; $idat <= $#fldnames; $idat++) 
         {
            $fldnames[$idat] =~ tr/a-z/A-Z/;
            if ($fieldname[$ii] eq $fldnames[$idat] )
            {
               $tord[$ii] = $idat;
          #    print "$idat, tord[$ii] = $tord[$ii], fieldname[$ii]=$fieldname[$ii],";
          #    print "fldname = $fldnames[$tord[$ii] ]<BR> \n";
            }
         }
      }

      $imsize = -1;
      print "<A NAME=\"product_data\"></A>\n";
      print "<A HREF=\"#pagetop\">(top of page)</A><BR>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4> Product Specifications for Model $pdmodel </FONT><P>\n";
      print "<TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($ii=0; $ii <= $#fldnames; $ii++)
      {
          $fldnames[$ii] =~ tr/a-z/A-Z/;
          if ($fldnames[$ii] eq 'MODEL')
          {   $imodel = $ii; }
          if ($fldnames[$ii] eq 'MODELSIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'MODEL_SIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
      }
      for ($i=0; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] ";
         if($units[$i] ne '') { print "<BR> ($units[$i])";}
         print "</TD>\n";
      }
      print "</TR>\n";

      $procedure = 'write_roomair_page2.sh?';
      &ora_bind ($csrc, $pdmodel);
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          print "<TR> \n";
          if ($imsize >= 0)
          {
             $mdl = $pdata[$imodel].$pdata[$imsize];
             $mdlstr = 'mdlno='.$pdata[$imodel].'&mdlsize='.$pdata[$imsize];
             print "<TD ALIGN=CENTER>";
             print "<A HREF=\"$perlpath$procedure$mdlstr\">$mdl</A></TD>\n";
          }
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>\n";
          }
          print "</TR>\n";
      }
      print "</TABLE><HR>\n";
      $currentdate = &formatdate;
      print "<FONT SIZE=2>$currentdate</FONT>\n";
      print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";
      print "</CENTER>\n";

    # print "</TABLE></CENTER>\n";
      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

   print "<A NAME=\"pagetop\"></A>\n";
   print "<P><BR>\n";

   print "<A HREF=\"$oraclepath/CSEARCH.list_all_models1\"><I>back to model search</I></A>\n";
   print "<P>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   &ora_bind ($csrtab, $modelin);
   ($tablename) = &ora_fetch($csrtab);
   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "(product specifications)</A><BR>\n";
   }
   &ora_close($csrtab);

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   &ora_bind ($csra, $modelin);
   &ora_bind ($csrb, $modelin);
   &ora_bind ($csrc, $modelin, 'product page');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelin <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      &write_comment ("$model has photo file [$photo_filename]-[$photo_extension] for page [$photo_pagetype]<BR>");
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;
      $photo_filename_uc = $photo_filename_uc.".jpg";
      $photo_filename_lc = $photo_filename_lc.".jpg";
      $IMG_SRC = $docpath."com_media/".$photo_filename_uc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_lc;
   #  print "Unix photo filename is [$photo_filename]<P>\n";
   #  print "Unix IMG SRC is [$IMG_SRC]<BR>\n";

      $IMG_SRC = \"$IMG_SRC\"\n";
      $IMG_ALT = \"$IMG_ALT\"\n";
      print "<CENTER>\n";
   #  print "Image goes here<BR>\n";
      print "<IMG SRC =\"$IMG_SRC  ALT=\"$IMG_ALT ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   &ora_close($csrb);
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
       &write_comment( "number of text files is $ntext ");
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
         &write_comment( "$model has text file [$text_filename]-[$text_extension] for page [$text_pagetype]");
         $text_filename =~ s/\s/_/g;
         $text_filename =~ s/-/_/g;
         $text_filename = $text_filename.".html";
         $text_location = $textpath.$text_filename;
      #  print "Unix text filename is [$text_filename]<P>\n";
         &write_comment( "Unix location is [$text_location]");
         $text_link = $text_location;
      }
      &ora_close($csra);
      open(TEXTFILE, $text_link) || &write_comment ("can't open filename $text_link");
      while (<TEXTFILE>)
      {
         chop;
         print "$_\n";
      } 
      close TEXTFILE;
   }

   &write_default_table_roomair ($modelin);   
}

# ******************************************
# Writes download links for model
# ******************************************
sub write_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND TO_NUMBER(a.downloadable) = 1
                      AND a.obsolete IS NULL
                      AND b.model = :1";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);

}
# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Product Specification Table and Information</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

