#!/bbn/bin/perl

# -----------------------
# filename:
# write_download_install.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("Install Page for Carrier Software Download");
# ===== HTML setup ======


# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ==============  define cursors =============================
  $GET_HEADER_DOC =
                 "SELECT filename, extension
                    FROM text_objects 
                   WHERE textid = :1";
 
# Elec lit (64); Elec catalog (51); CAD templates (37)

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno  = $value[0];
  $instid   = $value[1];
  $dlmodel  = $value[2];

  print "<P><BR>\n";

  &print_installpage($modelno, $instid, $dlmodel);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================

# ******************************************************
# Prints Download License Page for Comm level 1 documents
# ******************************************************
sub print_installpage
{
   local ($modelin, $installid, $dnldmodel) = @_;

   $GET_ELEC_LIT =
              "SELECT downloadfiletype, filename, extension
                 FROM download_links
                WHERE model = :1
                  AND downloadmodel = :2
                  AND TO_NUMBER(downloadable) = 1
                  AND obsolete IS NULL";

   $GET_TEXT_FILENAME =
              "SELECT filename, extension 
                 FROM text_objects
                WHERE textid = :1";


   $csrtxt = &ora_open ($lda, $GET_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";
   $csrinfo = &ora_open ($lda, $GET_ELEC_LIT) 
                   || print "failed to open cursor $GET_ELEC_LIT<BR>\n";

   print "<A NAME=\"top\"></A>\n";
   $prodpage = $plpath.'write_com_fieldpage.sh?modelno=';
   $prodpage = $prodpage.$modelin;
   print "<A HREF=\"$prodpage\"><I>back to product page</I></A><P>\n";

   &ora_bind($csrinfo, $modelin, $dnldmodel);
   while ( ($dltype, $dlfilename, $dlfext) = &ora_fetch($csrinfo) )
   {
      $dlfilename =~ s/ /_/g;
      $dlfilename =~ s/-/_/g;
      $dnldfilename = join('.', $dlfilename, $dlfext);
      &write_comment("download filename is $dnldfilename; extension is $dlfext\n");
      $dnldtype = $dltype;
   }
   print "<A  HREF=\"$dldirectory$dnldfilename\" ><B>Download File $dnldfilename</B></A>\n";
   print "</NOBR><BR>\n";
   print "<P>\n";

   $instnum = 0;
   &ora_bind($csrtxt, $installid);
   while ( ($inst_filename, $inst_ext) = &ora_fetch($csrtxt) )
   {
      $inst_filename =~ s/ /_/g;
      $inst_filename =~ s/-/_/g;
      $instnum = $instnum +1;
      &write_comment("install filename is $inst_filename; extension is $inst_ext\n");
      $instfile = $textpath.$inst_filename.'.html';
      open (INSTALL, "$instfile") || print "failed to open $instfile.\n";
      while (<INSTALL>)
      {
         chop;
         print "$_\n";
      }
   }

   print "<P>\n";

   print "<A HREF=\"#top\"><I>(top of page)</I></A>\n";
   
   &ora_close($csrtxt);
   &ora_close($csrinfo);
}
