#!/usr/local/bin/perl54

# -----------------------
# filename: write_download_install_rc.pl
# revision 9/98
# written august 1996
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  end of cursors =============================

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

# ====oraperl setup =====
  &oracle_login;
# ====oraperl setup =====

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ============================================================
# =================== body of program ========================

  &get_query;

  $instid   = $value[0];
  $dlmodel  = $value[1];

  print "<P><BR>\n";

  &print_installpage($instid, $dlmodel);

# ==================end  body of program =====================
# ============================================================
# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
#      log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ============================================================

# ******************************************************
# Prints Download License Page for Comm level 1 documents
# ******************************************************
sub print_installpage
{
   local ($installid, $dnldmodel) = @_;


   $csrtxt = &ora_open ($lda, $GET_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";
   $csrinfo = &ora_open ($lda, $GET_ELEC_LIT_RC) 
                   || print "failed to open cursor $GET_ELEC_LIT_RC<BR>\n";

   print "<A NAME=\"top\"></A>\n";

   &ora_bind($csrinfo,  $dnldmodel);
   while ( ($dltype, $dlfilename, $dlfext) = &ora_fetch($csrinfo) )
   {
      $dlfilename =~ s/ /_/g;
      $dlfilename =~ s/-/_/g;
      $dnldfilename = join('.', $dlfilename, $dlfext);
      &write_comment("download filename is $dnldfilename; extension is $dlfext\n");
      $dnldtype = $dltype;
   }
   print "<A  HREF=\"$dldirectory$dnldfilename\" ><B>Download File $dnldfilename</B></A>\n";
   print "</NOBR><BR>\n";
   print "<P>\n";

   $instnum = 0;
   &ora_bind($csrtxt, $installid);
   while ( ($inst_filename, $inst_ext) = &ora_fetch($csrtxt) )
   {
      $inst_filename =~ s/ /_/g;
      $inst_filename =~ s/-/_/g;
      $instnum = $instnum +1;
      $instfile = $textpath.$inst_filename.'.html';
      &write_comment("install file is $instfile \n");
      open (INSTALL, "$instfile") || print "failed to open $instfile.\n";
      while (<INSTALL>)
      {
         chop;
         print "$_\n";
      }
   }
   print "<P>\n";

   print "<A HREF=\"#top\"><I>(top of page)</I></A>\n";
   
   &ora_close($csrtxt);
   &ora_close($csrinfo);
}
