
   $CAES_CHILLER =
                          "SELECT *
                             FROM CAES_CHILLER
                            WHERE model = :1
                            ORDER BY TO_NUMBER(nomcap)";

   $CMUS_AIR_CONDENSER = 
                          "SELECT *
                             FROM CMUS_AIR_CONDENSER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_AIR_HANDLER =
                          "SELECT *
                             FROM CMUS_AIR_HANDLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";
   
   $CMUS_AIR_TERMINAL =
                          "SELECT *
                             FROM CMUS_AIR_TERMINAL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomairflow)";

   $CMUS_AIR_TERMINAL_BOX =
                          "SELECT *
                             FROM CMUS_AIR_TERMINAL_BOX
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomairflow)";

   $CMUS_BOOT_DIFFUSER =
                          "SELECT *
                             FROM CMUS_BOOT_DIFFUSER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomairflow)";

   $CMUS_CHILLER =
                          "SELECT *
                             FROM CMUS_CHILLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_DUAL_FUEL_HEAT_PUMP =
                          "SELECT *
                             FROM CMUS_DUAL_FUEL_HEAT_PUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_FANCOILS =
                          "SELECT *
                             FROM CMUS_FANCOILS
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(netclgcap)";

   $CMUS_INDOOR_HORZ_PACK =
                          "SELECT *
                             FROM CMUS_INDOOR_HORZ_PACK
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";
 
   $CMUS_INDOOR_VERT_PACK =
                          "SELECT *
                             FROM CMUS_INDOOR_VERT_PACK
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_INDUCTION_UNIT =
                          "SELECT *
                             FROM CMUS_INDUCTION_UNIT
                            WHERE model = :1";

   $CMUS_LPACKROOF_EHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_LPACKROOF_EHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_LPACKROOF_GHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_LPACKROOF_GHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACKROOF_EHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_PACKROOF_EHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACKROOF_GHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_PACKROOF_GHEAT_ECOOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_AIR_HANDLER =
                          "SELECT *
                             FROM CMUS_PACK_AIR_HANDLER
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_ELEC_COOL =
                          "SELECT *
                             FROM CMUS_PACK_ELEC_COOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_GAS_HEAT_ELEC_COOL =
                          "SELECT *
                             FROM CMUS_PACK_GAS_HEAT_ELEC_COOL
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_HEATING_AND_COOLING =
                          "SELECT *
                             FROM CMUS_PACK_HEATING_AND_COOLING
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_HEATPUMP =
                          "SELECT *
                             FROM CMUS_PACK_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_ROOFTOP_HEATPUMP =
                          "SELECT *
                             FROM CMUS_PACK_ROOFTOP_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_PACK_TERMINAL_UNIT =
                          "SELECT *
                             FROM CMUS_PACK_TERMINAL_UNIT
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $CMUS_ROOFTOP_EHEAT_ECOOL =
                          "SELECT *
                             FROM CMUS_ROOFTOP_EHEAT_ECOOL
                            WHERE model = :1";

   $CMUS_SPLIT_SYSTEM =
                          "SELECT *
                             FROM CMUS_SPLIT_SYSTEM
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(condunitclgcap)";

   $CMUS_SPLIT_SYSTEM_HEATPUMP =
                          "SELECT *
                             FROM CMUS_SPLIT_SYSTEM_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize";

   $CMUS_UNIT_VENTILATOR =
                          "SELECT *
                             FROM CMUS_UNIT_VENTILATOR
                            WHERE model = :1
                            ORDER BY TO_NUMBER(modelsize), TO_NUMBER(nomairflow)";

   $CMUS_WATER_SOURCE_HEATPUMP =
                          "SELECT *
                             FROM CMUS_WATER_SOURCE_HEATPUMP
                            WHERE model = :1
                            ORDER BY modelsize, TO_NUMBER(nomcap)";

   $RAC_UNITS_HC =
                          "SELECT *
                             FROM RAC_UNITS_HC
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_COOL_ONLY =
                          "SELECT *
                             FROM RAC_UNITS_COOL_ONLY
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_HEAT_COOL =
                          "SELECT *
                             FROM RAC_UNITS_HEAT_COOL
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";

   $RAC_UNITS_HEAT_PUMP =
                          "SELECT *
                             FROM RAC_UNITS_HEAT_PUMP
                            WHERE model = :1
                            ORDER BY model_size, TO_NUMBER(cool_capacity)";


