# ******************************
# download queries
# ******************************

  $GET_HEADER_DOC =
                 "SELECT filename, extension
                    FROM text_objects 
                   WHERE textid = :1";
 
  $GET_ELEC_LIT =
              "SELECT downloadfiletype, filename, extension
                 FROM download_links
                WHERE model = :1
                  AND downloadmodel = :2
                  AND TO_NUMBER(downloadable) = 1
                  AND obsolete IS NULL";

  $GET_ELEC_LIT_RC =
              "SELECT downloadfiletype, filename, extension
                 FROM download_objects
                WHERE downloadmodel = :1
                  AND downloadable=1
                  AND obsolete IS NULL";

  $GET_ELEC_LIT_LINKS  =
               "SELECT downloadfiletype, filename, extension, description,
                       fileformat, disksize, downloadable, descriptionid,
                       licenseid, installid, downloadmodel 
                  FROM download_objects
                 WHERE upper(extension) LIKE :1
                   AND upper(downloadfiletype) LIKE :2
                   AND downloadable = 1
                   AND obsolete IS NULL
                 ORDER BY description, downloadmodel";

  $GET_TYPE_DESCRIPTION =
                 "SELECT description 
                    FROM download_object_types
                   WHERE downloadfiletype = :1";

  $GET_DL_TEXT_FILENAME =
              "SELECT filename, extension 
                 FROM text_objects
                WHERE textid = :1";

