#!/bbn/bin/perl

# -----------------------
# filename:
# write_com_fieldpage.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

# ===== HTML setup ======
  &html_header_1("Product Specification Table and Information");
# ===== HTML setup ======

  &write_comment("End of HTML setup; 8/98 revision");

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ============================================================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $unit_type = $value[1];

  &write_comment("model is $modelno; unit type is $unit_type");

  &write_modelpage ($modelno);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

   &caw_frameD_back_header;
   print "<P>\n";
   &back_to_caw_products;
   print "<BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   $modeluc = $modelin; 
   $modeluc =~ tr/a-z/A-Z/;
   &ora_bind ($csrtab, $modeluc);

   ($tablename, $modelalias) = &ora_fetch($csrtab);
   if ($DEBUG > 0) {
      &write_comment(" input model is $modeluc, alias is $modelalias");
   }

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }

   if ($modelalias ne '') { $modelprt = $modelalias; }
   else { $modelprt = $modelin; }

   &ora_close($csrtab);

   &write_comment(" input model is $modelin, alias is $modelalias\n");

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   &display_graphic($modeluc);

   print "<P><P>\n";

   &display_productpage_text($modeluc);

   &write_default_table ($modelin, $unit_type); 

   &frameD_topofpage;
}
