#!/bbn/bin/perl

# -----------------------
# filename:
# write_com_modelpage.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("Commercial Model Page");
# ===== HTML setup ======

  print "<!-- 9/98 revision --><BR>\n";
  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  define cursors =============================
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   ORDER BY datatablename";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";
# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

# this is a dummy routine

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# ***************************************************
# This Procedure shows default and display fields 
# ***************************************************
sub show_default_table_fields {

   $csra  = &ora_open($lda, $GET_TABLE) || die $ora_errstr;
   $csrb  = &ora_open($lda, $GET_DEFAULT_FIELDS) || die $ora_errstr;
   $csrc  = &ora_open($lda, $GET_DISPLAY_FIELDS) || die $ora_errstr;

   while ( ($pdtblname ) = &ora_fetch($csra) )  
   {
      $pdtblname =~ tr/a-z/A-Z/;
      print "<BR><HR>\n";
      print "<BR>Data Table is $pdtblname;<BR> Default Fields:<P>\n";
      $pdtablename = $pdtblname;


      &ora_bind ($csrb, $pdtablename);
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder) = &ora_fetch($csrb) ) 
      {
         $ii++;
         print "default order_num is $forder for $fname alias $fdname, 
            with colname $cname <BR>\n";
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
      }
      print "<CENTER><TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($i=1; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] </TD>\n";
      }
      print "</TR>\n";
      print "</TABLE></CENTER>\n";

      for ($i=1; $i <= $#ord; $i++) {
         $columnname[$i] = '';
      }

      print "<P>Display Fields:<P>\n";
      &ora_bind ($csrc, $pdtablename);
      while ( ($fcname, $ccname, $fcdname, $fcorder) = &ora_fetch($csrc) ) 
      {
         print "display order_num is $fcorder for $fcname alias $fcdname, 
            with colname $ccname <BR>\n";
      }
   }    
   &ora_close($csrb);
   &ora_close($csra);
   &ora_close($csrc);
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Product Data Table and Information</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

