#!/bbn/bin/perl

# -----------------------
# filename:
# revised for perl5/DBI/DBD
#  & GTE website 9/98
# revisions Aug 1998
# staging site
# write_cmodel_seguepage.pl
# written august 20 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_specs.pl';
require '/home/www.na.carrier.com_cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/product_queries.pl';
#require '/home/www.na.carrier.com_cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================


# ===== HTML setup ======
  &html_header_1("Write Commercial Modelpage Segues");
# ===== HTML setup ======

  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelstr = $value[0];

  &write_model_seguepage ($modelstr);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# **********************************************************************
# Writes the segue to the product page for the generaltype/specifictype
# **********************************************************************
sub write_model_seguepage
{
   local ($mdlstr) = @_;

   &caw_frameD_back_header;
   &back_to_caw_model_search;
   print "<P><BR>\n";

   $csrcnt = &ora_open($lda, $COUNT_MODELS) || print "failed to open $COUNT_MODELS\n";
   $mdl = '%'.$mdlstr;
   $mdl = $mdl.'%';
   $mdl =~ tr/a-z/A-Z/;
   &ora_bind ($csrcnt, $mdl);
   ($mdlcount) = &ora_fetch($csrcnt);
   &ora_close($csrcnt);

   print "<CENTER><FONT SIZE=4>\n";
   print "Search Results<P>\n";
   print "The search for [$mdlstr] returned $mdlcount items.<BR>\n";
   print "</FONT></CENTER>\n";
   print "<P>\n";

   $csrmod = &ora_open($lda, $GET_MODEL_BY_SUBSTR) || die $ora_errstr;
   $csra   = &ora_open($lda, $GET_SEGUE_FILENAME) || die $ora_errstr;
   $csrc   = &ora_open($lda, $CHECK_SEGUE_TEXT) || die $ora_errstr;

   &write_comment("modelstring is $mdlstr\n");

   $modelin = "%$mdlstr%";
   $modelin =~ tr/a-z/A-Z/;
   &ora_bind ($csrmod, $modelin);

   &write_comment("after ora_bind to string ($modelin) of get_model cursor\n");


   $ii = 0;
   while ( ($mdl, $mdlalias) = &ora_fetch($csrmod) )
   {
      $model[$ii] = $mdl;
      $modelalias[$ii] = $mdlalias;

      &write_comment("$ii model is $model[$ii] \n");

      if ($modelalias[$ii] ne '')  
      {
         $modelname = $modelalias[$ii].' ('.$model[$ii].')';
      }
      else 
      {
         $modelname = $model[$ii];
      }
      $htmodelname = $model[$ii];
      $htmodelname =~ s/ /+/g;
      $htmodelname =~ s/-/%2D/g;

       if ($unittype eq '')
      {
         $unittype = 'English';
         $newunittype ='Metric';
      }
      $unitstring = "&unittype=$unittype";


      $hreflink = '/CMODDOCS.load_commdl_page?modelno=';
      print "<BR><FONT SIZE=4>\n";
      print "<A  TARGET=\"_parent\" HREF=\"$oraclepath$hreflink$htmodelname$unitstring\" >\n";
      print "$modelname</A><P>\n";
      print "</FONT>\n";

      $uppermodel = $model[$ii];
      $uppermodel =~ tr/a-z/A-Z/;
      &ora_bind($csrc, $uppermodel);
      while ( ($textno) = &ora_fetch ($csrc) )
      {
          $ntext = $textno;
          &write_comment("number of text files is $ntext \n");
      }

      if ($ntext == 0) 
      {
         print "<UL>\n";
         &write_comment("ntext = $ntext");
         print "<P><P>\n";
         print "</UL>\n";
      }
      if ($ntext > 0 )
      {
         $uppermodel = $model[$ii];
         $uppermodel =~ tr/a-z/A-Z/;
         &ora_bind ($csra, $uppermodel);
         while (  ($text_filename, $text_extension, $text_pagetype)
            = &ora_fetch($csra) )
         {
       #    print "$model[$ii] has text file [$text_filename]-[$text_extension] for page [$text_pagetype]<BR>\n";
            $text_filename =~ s/\s/_/g;
            $text_filename =~ s/-/_/g;
            $text_filename =~ s/&/and/g;
            $text_filename = $text_filename.".html";
            $text_location = $textpath.$text_filename;
            $print_text = "Unix text filename is [".$text_filename;
            &write_comment($print_text);
            $text_link = $text_location;
         }
         print "<UL>\n";
         open(TEXTFILE, $text_link) || print "<P><P>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
         print "</UL>\n";
         print "<P>\n";
      }
      $ii++;
   }
   &ora_close ($csra);
   &ora_close ($csrc);
   &ora_close($csrmod);

   &frameD_topofpage;

   &write_download_links ($modelin);
}

