#!/usr/local/bin/perl54

# -----------------------
# filename:
# write_com_seguepage.pl
# written august 20 1996
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/product_queries.pl';
# ==============  end of cursors =============================

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

  print "<!-- 8/98 revision --><BR>\n";
  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ============================================================
# =================== body of program ========================

  $query_string = $ENV{'QUERY_STRING'};
##   print "Query String is set to $query_string <BR>\n";

# Parse input query string
  &parse($query_string);

  $generaltype = $value[0];
  $specifictype = $value[1];

  &write_seguepage ($generaltype, $specifictype);

# ==================end  body of program =====================
# ============================================================
# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====
# ==========================================================
# ================= oraperl cleanup ========================
# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# **********************************************************************
# Writes the segue to the product page for the generaltype/specifictype
# **********************************************************************
sub write_seguepage
{
   local ($gentype, $spectype) = @_;

   local ($unittype);
   $unittype = 'English';

   &caw_frameD_back_header;
   &back_to_caw_products;
   print "<P><BR>\n";

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>$gentype: $spectype <BR>\n";
   print "</FONT></CENTER>\n";
   print "<P><P>\n";

   $csrmod = &ora_open($lda, $GET_MODEL) || die $ora_errstr;
   $csra   = &ora_open($lda, $GET_SEGUE_FILENAME) || die $ora_errstr;
   $csrc   = &ora_open($lda, $CHECK_SEGUE_TEXT) || die $ora_errstr;

   if ($DEBUG > 0) {
      &write_comment("general type is $gentype; specific type is $spectype\n");
   }

   $bindstatus = &ora_bind ($csrmod, $gentype, $spectype);


   $ii = 0;
   while ( ($mdl, $mdlalias) = &ora_fetch($csrmod) )
   {
      $model[$ii] = $mdl;
      $modelalias[$ii] = $mdlalias;

      if ($DEBUG > 0) {
         &write_comment("$ii model is $model[$ii] \n");
      }

      if ($modelalias[$ii] ne '')  
      {
         $modelname = $modelalias[$ii];
      }
      else 
      {
         $modelname = $model[$ii];
      }
      $htmodelname = $model[$ii];
      $htmodelname =~ s/ /+/g;
      $htmodelname =~ s/-/%2D/g;
      $hreflink = '/CPUTT.load_com_product_info?modelno=';
      $unitlink = '&unittype='.$unittype;
      print "<BR><FONT SIZE=4>\n";
      print "<A  TARGET=\"_top\" HREF=\"$oraclepath$hreflink$htmodelname$unitlink\" >\n";
      print "$modelname</A><P>\n";
      print "</FONT>\n";

      $uppermodel = $model[$ii];
      $uppermodel =~ tr/a-z/A-Z/;
      $bstatus = &ora_bind($csrc, $uppermodel);
      if ($DEBUG > 0) {
         print "<!-- bind status of $uppermodel to text count is $bstatus -->\n";
      }
      while ( ($textno) = &ora_fetch ($csrc) )
      {
          $ntext = $textno;
          if ($DEBUG > 0) {
             &write_comment("number of text files is $ntext \n");
          }
      }

      if ($ntext == 0) 
      {
         print "<UL>\n";
         print "<P><P>\n";
         print "</UL>\n";
      }
      if ($ntext > 0 )
      {
         $uppermodel = $model[$ii];
         $uppermodel =~ tr/a-z/A-Z/;
         &ora_bind ($csra, $uppermodel);
         while (  ($text_filename, $text_extension, $text_pagetype)
            = &ora_fetch($csra) )
         {
            $text_filename_stem = $text_filename;
            $text_filename_stem =~ s/\s/_/g;
            $text_filename_stem =~ s/-/_/g;
            $text_filename_stem =~ s/&/and/g;
            $text_filename = $text_filename_stem.".html";
            $text_location = $textpath.$text_filename;
            $print_text = "Unix text filename is [".$text_filename;
           #&write_comment($print_text);
            $text_filenameA = $text_filename_stem.".HTM";
            $text_locationA = $textpath.$text_filenameA;
            $text_filenameB = $text_filename_stem.".htm";
            $text_locationB = $textpath.$text_filenameB;
            
            if ($DEBUG > 0) {
               &write_comment ("Unix location is [$text_location] or [$text_locationA] or [$text_locationB]");
            }
            $text_link = $text_location;
            $text_linkA = $text_locationA;
            $text_linkB = $text_locationB;
         }
         print "<UL>\n";
         open(TEXTFILE, $text_link) || open(TEXTFILE, $text_linkA) 
                                    || open(TEXTFILE, $text_linkB) || print "<P><P>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
         print "<BR>\n";
         print "</UL>\n";
         print "<P>\n";

#        &write_model_download_links ($modelin);
      }
      $ii++;
   }
   &ora_close ($csra);
   &ora_close ($csrc);
   &ora_close($csrmod);

   &frameD_topofpage;

}

